(function() {
"use strict";

this.name           = "Mine Script";
this.author         = "Docwild";
this.copyright      = "GNU GENERAL PUBLIC LICENSE";
this.licence        = "GNU GENERAL PUBLIC LICENSE";
this.description    = "Mining and yoursing, too";
this.version        = "1.0 beta 1";

//script member props
let L = false;


this.begin = true;

//Javascripts solution to static variables :/

this.firstActDone = false;


//ship member prop flags
this.ship.toldUCA = false; //UCA = asteroidUnclaimedAttacked
this.ship.toldSAC = false; //SAC = shipApproachClaimed
this.ship.toldSAP = false; //SAP = shipApproachPlayers (mine)
this.ship.toldACA = false; //ACA = asteroidClaimedAttacked
this.ship.toldAOA = false; //AOA = asteroidOwnedAttacked
this.ship.playerDetectedFlag = false;
this.ship.asteroidAttackedFlag = false;

this.ship.defenderGroup = new ShipGroup();
this.ship.defenderGroup.name = "Mine Defence";
//this.delay = parseFloat((this.ship.position.distanceTo(player.ship.position)/18600));// light :/

this.lostPlayer = function()
{//reset some stuff
	this.ship.toldUCA = false; //UCA = asteroidUnclaimedAttacked
	this.ship.toldSAC = false; //SAC = shipApproachClaimed
	this.ship.toldSAP = false; //SAP = shipApproachPlayers (mine)
	this.ship.toldACA = false; //ACA = asteroidClaimedAttacked
	this.ship.toldAOA = false; //AOA = asteroidOwnedAttacked
	this.ship.playerDetectedFlag = false;
}




this.shipDied = function(whom, why)
{
	if(L)
		log(this.name, "shipdied");
	if( whom == player)
	{

		if(L)
		{
			log(this.name, "asteroid lost.");
			
		}	
		//players asteroid claim lost
		player.consoleMessage("You destroyed a slaveMine.");

	}
	for(var i = 0; i < worldScripts.miningScript.systemAsteroidObjects.length; i ++)
    {
        var mine = worldScripts.miningScript.systemAsteroidObjects[i].get();
        if (this.ship.position.distanceTo(mine.position)<1000)
        {
            worldScripts.miningScript.systemAsteroidObjects = worldScripts.miningMethods.removeFromArray(worldScripts.miningScript.systemAsteroidObjects, i);
            break;
        }
    }
	if (L) log(this.name, "shipDied call rebuildPerpVariables");
	worldScripts.miningMethods.rebuildPerpVariables();
}

this.asteroidClaimDestroyed = function()
{
    Sound.stopMusic(worldScripts.miningScript.hostileMusic);
    var astObject = null; 
    var n = null;
    if(L)
    {
        log(this.name, "asteroid claim destroyed not told yet");
    }



    for(var i = 0; i < worldScripts.miningScript.systemAsteroidObjects.length; i++)
    {
        var claimedPosition = Vector3D(worldScripts.miningScript.systemAsteroidObjects[i].minePos);
        if (claimedPosition.distanceTo( this.ship.position) < 1000)
        {
           
            //worldScripts.miningMethods.replaceWithUnclaimed.push(worldScripts.miningMethods.playerClaimedPositions[i]);
            astObject = worldScripts.miningMethods.getObject(claimedPosition);
            n = i;
            if (L) log(this.name, "this is the one: claimedPosition = " + claimedPosition + " astObject = "+ astObject + " n = " + n);
        }
    }
    if(astObject != null && astObject.mineStatus != "-UNCLAIMED")
    {
        if(astObject.mineStatus == "-OWNED")
        {
            this.ship.commsMessage("Asteroid claim destroyed.");

            if(L)
            {
                log(this.name, "Own asteroid claim destroyed.");

            }
            //players asteroid claim lost
            player.consoleMessage("Owned asteroid claim destroyed.", 5);

            

            astObject.lostClaim();//reset mine, beacon persists
            worldScripts.miningMethods.removeOwnedOverload(astObject.minePos);


        }
        else if (astObject.mineStatus == "-CLAIMED")
        {
            this.ship.commsMessage("Asteroid claim destroyed.");

            if(L)
            {
                log(this.name, "Someone's asteroid claim destroyed.");

            }

            this.ship.commsMessage("Asteroid claim destroyed.");

        }
    
	
        astObject.changeType("SlaveMine-UNCLAIMED");
        astObject.mineStatus = "-UNCLAIMED";
    }
	//this.ship.switchAI("unclaimedAsteroidAI.plist");
}

this.asteroidAttacked = function ()
{
	if(L)
		log(this.name, "asteroidAttacked...this.displayName: " + this.ship.displayName);
    if(!this.asteroidAttackedFlag)
    {
        this.asteroidAttackedFlag = true;
        Sound.stopMusic(worldScripts.miningScript.inRangeMusic);
        Sound.playMusic(worldScripts.miningScript.hostileMusic, true);
    }
	switch (worldScripts.miningMethods.returnTag(this.ship.displayName))
	{
		case "-OWNED":
			
			if(!this.ship.toldAOA)
			{
				if(L)
					log(this.name, "asteroid owned attacked");
				if(this.ship.playerDetectedFlag)
				{
					this.ship.commsMessage("What are you doing?"); 
					this.ship.toldAOA = true;
				}
			}
			else
				this.ship.commsMessage("You are a pyscho! It has been logged."); 
			break;
		case "-UNCLAIMED":
			
			if(!this.ship.toldUCA)
			{
				if(L)
					log(this.name, "asteroid unclaimed attacked");
				if(this.ship.playerDetectedFlag)
				{
					this.ship.commsMessage("No need for violence, no claim exists here!");
					this.ship.toldUCA = true;
				}
			}
			break;
		case "-CLAIMED":
			
			var defender = this.ship.launchPirateShip();
			if(this.ship.hasHostileTarget && defender)
				defender.target = this.ship.target;
			if(!this.ship.toldACA)
			{
				
				if(this.ship.playerDetectedFlag)
				{
					if(L)
						log(this.name, "asteroid claimed attacked");
					this.ship.commsMessage("It's easy to attack people in the cold loneliness of space. Your details have been logged."); 
					this.ship.toldACA = true;
				}
			}
			break;
	}
}

this.playerNotDetected = function ()
{
	//playerDetectedFlag = false;
    if(this.ship.playerDetectFlag)
    {
        Sound.stopMusic(worldScripts.miningScript.inRangeMusic);
        this.ship.playerDetectFlag = false;
        
    }
}
this.playerDetected = function()
{
	if(L)
		log(this.name, "playerDetected");
    if(!this.ship.playerDetectedFlag)
    {
        this.ship.playerDetectedFlag = true;
        Sound.playMusic(worldScripts.miningScript.inRangeMusic);
    }
	switch (worldScripts.miningMethods.returnTag(this.ship.displayName))
	{
		case "-OWNED":
			if(L)
				log(this.name, "owned");
			if(!this.ship.toldSAP)
			{
				this.ship.commsMessage("Good to see a friendly face");
				this.ship.toldSAP = true;
			}
			break;
		case "-UNCLAIMED":
			if(L)
				log(this.name, "unclaimed");
			if(!this.ship.toldUCA)
			{
				
				this.ship.commsMessage("Do you have supplies?");
				this.ship.toldUCA = true;
			
				
			}
			break;
		case "-CLAIMED":
			if(L)
				log(this.name, "asteroid claimed attacked");
            var prob = Math.floor(Math.random()*20) + 1;
			if(prob > 0)
			{
                Sound.stopMusic(worldScripts.miningScript.inRangeMusic);
                Sound.playMusic(worldScripts.miningScript.hostileMusic);
                
                
                
				var defender = this.ship.launchPirateShip();
				if(defender)
                {
                    defender.group = defenderGroup;
                    defender.target = player.ship.target;
                    
                }
			}
			if(!this.ship.toldSAC)
			{
				if(this.ship.playerDetectedFlag)
				{
					this.ship.commsMessage("You are entering a restricted zone. Claims exist here!");
					this.ship.toldSAC = true;
				}
			}
			break;
	}
	
	
}

}).call(this);
